import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["value", "children", "isOpen", "onToggle", "onChange", "leftIcon", "iconArrowDown", "refMoleculeSelect", "size", "placeholder", "id", "disabled", "optionsData", "required", "tabIndex"];
import { useState } from 'react';
import PropTypes from 'prop-types';
import AtomInput, { inputSizes as SELECT_SIZES, inputTypes } from '@s-ui/react-atom-input';
import MoleculeDropdownList from '@s-ui/react-molecule-dropdown-list';
import { useDropdown } from '../config.js';
import MoleculeInputSelect from './MoleculeInputSelect.js';
import Search from './Search.js';
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
var MoleculeSelectSingleSelection = function MoleculeSelectSingleSelection(_ref) {
  var _ref$value = _ref.value,
    value = _ref$value === void 0 ? '' : _ref$value,
    children = _ref.children,
    isOpen = _ref.isOpen,
    onToggle = _ref.onToggle,
    onChange = _ref.onChange,
    leftIcon = _ref.leftIcon,
    iconArrowDown = _ref.iconArrowDown,
    refMoleculeSelect = _ref.refMoleculeSelect,
    size = _ref.size,
    placeholder = _ref.placeholder,
    id = _ref.id,
    disabled = _ref.disabled,
    _ref$optionsData = _ref.optionsData,
    optionsData = _ref$optionsData === void 0 ? {} : _ref$optionsData,
    required = _ref.required,
    tabIndex = _ref.tabIndex,
    props = _objectWithoutPropertiesLoose(_ref, _excluded);
  var _useDropdown = useDropdown(),
    hasSearch = _useDropdown.hasSearch,
    isFirstOptionFocused = _useDropdown.isFirstOptionFocused,
    inputSearch = _useDropdown.inputSearch;
  var _useState = useState(false),
    focusedFirstOption = _useState[0],
    setFocusedFirstOption = _useState[1];
  var handleSelection = function handleSelection(ev, _ref2) {
    var value = _ref2.value;
    onChange(ev, {
      value: value
    });
    onToggle(ev, {
      isOpen: false
    });
    refMoleculeSelect && refMoleculeSelect.current && refMoleculeSelect.current.focus();
  };
  var handleKeyDown = function handleKeyDown(ev) {
    if (isFirstOptionFocused()) {
      setFocusedFirstOption(true);
    } else {
      setFocusedFirstOption(false);
    }
    if ((ev == null ? void 0 : ev.key) === 'Escape') {
      onToggle(ev, {
        isOpen: false
      });
    } else if ((ev == null ? void 0 : ev.key) === 'ArrowUp') {
      focusedFirstOption && setTimeout(function () {
        return inputSearch == null ? void 0 : inputSearch.focus();
      });
    }
  };
  return /*#__PURE__*/_jsxs(_Fragment, {
    children: [/*#__PURE__*/_jsx(MoleculeInputSelect, {
      disabled: disabled,
      id: id,
      isOpen: isOpen,
      value: optionsData[value] || '',
      onClick: function onClick(ev) {
        return onToggle(ev, {
          isOpen: !isOpen
        });
      },
      leftIcon: leftIcon,
      iconArrowDown: iconArrowDown,
      placeholder: placeholder,
      autoComplete: "off",
      required: required,
      size: size,
      tabIndex: tabIndex,
      children: /*#__PURE__*/_jsx(AtomInput, {
        inputMode: inputTypes.NONE
      })
    }), hasSearch && /*#__PURE__*/_jsx(Search, {}), /*#__PURE__*/_jsx(MoleculeDropdownList, {
      size: size,
      visible: isOpen,
      onSelect: handleSelection,
      value: value,
      onKeyDown: handleKeyDown,
      children: children
    })]
  });
};
MoleculeSelectSingleSelection.displayName = 'MoleculeSelectSingleSelection';
export default MoleculeSelectSingleSelection;